<?php defined( '_VALID_MOS' ) or die( 'Restricted access' );
/**
 * @ H2N Link Directory 1.0.0 admin.comments.php
 * @ Copyright (C) 2008 Harry Klein - www.joomla-hklein.de
 * @
 * @ Link Directory 1.1 admin.comments.php
 * @ Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 **/

function showComments( $option ) {
	global $database, $mainframe, $mosConfig_list_limit;

	$limit 		= intval( $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mosConfig_list_limit ) );
	$limitstart = intval( $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 ) );
	$search 	= $mainframe->getUserStateFromRequest( "search{$option}", 'search', '' );
	$search 	= $database->getEscaped( trim( strtolower( $search ) ) );
	$state 		= intval( $mainframe->getUserStateFromRequest( "state{$option}", 'state', 1 ) );

	$where = array();

	if ($search) {
		$where[] = "LOWER(a.rev_title) LIKE '%$search%'";
	}

	
	switch ($state) {
		case 0:
			$where[] = "a.rev_approved = 0";
			break;
		case 2:
			$where[] = "a.type > 0";
			break;
		case 3:
			$where[] = "a.type = 0";
			break;
		case 11:
		case 12:
		case 13:
		case 14:
			$where[] = "a.type = $state-10";
			break;
	}

	// get the total number of records
	$query = "SELECT COUNT(*)"
	. "\n FROM #__ldcomment AS a"
	. (count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : "")
	;
	$database->setQuery( $query );
	$total = $database->loadResult();

	require_once( _LD_ABSOLUTE_PATH.'/administrator/includes/pageNavigation.php');
	$pageNav = new mosPageNav( $total, $limitstart, $limit  );

	$query = "SELECT a.* FROM #__ldcomment AS a"
	. ( count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : "")
	. "\n ORDER BY a.rev_date DESC, a.link_id"
	. "\n LIMIT $pageNav->limitstart, $pageNav->limit"
	;
	$database->setQuery( $query );

	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	$count = count( $rows );
	// number of Active Items
	for ( $i = 0; $i < $count; $i++ ) {
		$query = "SELECT name"
		. "\n FROM #__users"
		. "\n WHERE id = ". $rows[$i]->user_id
		;

		$database->setQuery( $query );
		$user = $database->loadResult();
		$rows[$i]->user = $user;
	}

	$types[] = mosHTML::makeOption( '1', '- '._LD_SELECTSTATE.' -' );
	$types[] = mosHTML::makeOption( '0', '- '._LD_UNPB.' -' );
	$types[] = mosHTML::makeOption( '3', '- '._LD_COMENT_TYPE_0.' -' );
	$types[] = mosHTML::makeOption( '2', '- '._LD_COMENT_TYPE_1_4.' -' );
	$types[] = mosHTML::makeOption( '11', '- '._LD_COMENT_TYPE_1.' -' );
	$types[] = mosHTML::makeOption( '12', '- '._LD_COMENT_TYPE_2.' -' );
	$types[] = mosHTML::makeOption( '13', '- '._LD_COMENT_TYPE_3.' -' );
	$types[] = mosHTML::makeOption( '14', '- '._LD_COMENT_TYPE_4.' -' );

	$lists['state'] = mosHTML::selectList( $types, 'state', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', "$state" );

	Comments_HTML::Show( $option, $rows, $lists, $search, $pageNav );
}

function editComment( $option, $id ) {
	global $database;

	$row = new snrComments( $database );
	// load the row from the db table
	$row->load( $id );

	// build the html select list
	$lists['published'] 		= mosHTML::yesnoRadioList( 'published', 'class="inputbox"', $row->rev_approved );

	Comments_HTML::editComment( $row, $lists, $option );
}

function saveComment( $option ) {
	global $database, $my;

	$row = new snrComments( $database );

	if (!$row->bind( $_POST )) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}

	if (!$row->check()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}

	if (!$row->store()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	mosRedirect( "index2.php?option=$option&task=comments" );
}

function publishComments( $cid=null, $publish=1,  $option ) {
	global $database, $my;

	$catid = mosGetParam( $_POST, 'catid', array(0) );

	if (!is_array( $cid ) || count( $cid ) < 1) {
		$action = $publish ? 'publish' : 'unpublish';
		echo "<script> alert('Select an item to $action'); window.history.go(-1);</script>\n";
		exit;
	}

	$cids = implode( ',', $cid );

	$query = "UPDATE #__ldcomment"
	. "\n SET rev_approved = " . intval( $publish )
	. "\n WHERE rev_id IN ( $cids )"
	;
	$database->setQuery( $query );
	if (!$database->query()) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	mosRedirect( "index2.php?option=$option&task=comments" );
}

function removeComments( $cid, $option ) {
	global $database;

	if (!is_array( $cid ) || count( $cid ) < 1) {
		echo "<script> alert('Select an item to delete'); window.history.go(-1);</script>\n";
		exit;
	}
	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$query = "DELETE FROM #__ldcomment"
		. "\n WHERE rev_id IN ( $cids )"
		;
		$database->setQuery( $query );
		if (!$database->query()) {
			echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	mosRedirect( "index2.php?option=$option&task=comments" );
}

function CheckedOutProcessing( &$row, $i ) {
	global $my;

	if ( $row->checked_out) {
		$checked = mosCommonHTML::checkedOut( $row );
	} else {
		$checked = mosHTML::idBox( $i, $row->rev_id, ($row->checked_out && $row->checked_out != $my->id ) );
	}

	return $checked;
}
?>