<?php defined( '_VALID_MOS' ) or die( 'Restricted access' );
/**
 * @ H2N Link Directory 1.0.0 admin.linkdirectory.php
 * @ Copyright (C) 2008 Harry Klein - www.joomla-hklein.de
 * @
 * @ Link Directory 1.1 admin.linkdirectory.php
 * @ Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 *
 * @ $Id: admin.linkdirectory.php,v 1.13 2009/08/14 22:45:03 harry Exp $
 *
 **/


$path = preg_replace("!(\\\)!i","/",dirname(__FILE__));
define('_LD_ABSOLUTE_PATH', str_replace("/administrator/components/com_linkdirectory","",$path));
define('_LD_BACKEND_PATH', $path );
define('_LD_FRONTEND_PATH', _LD_ABSOLUTE_PATH.'/components/com_linkdirectory' );

//include mainframe support
require_once( $mainframe->getPath( 'admin_html' ) );
require_once( $mainframe->getPath( 'class' ) );

//include language support
if( defined('_JEXEC') ){
	$ld_lang=$mainframe->getCfg('language');
} else {
	$ld_lang=$mainframe->getCfg('lang');
}

if (file_exists(_LD_BACKEND_PATH.'/language/'.$ld_lang.'.php')){
	include_once(_LD_BACKEND_PATH.'/language/'.$ld_lang.".php");
}else{
	include_once(_LD_BACKEND_PATH.'/language/english.php');
}

//include config file
if (!file_exists(_LD_BACKEND_PATH.'/config.php')){
	echo 'Config File Not Found';
	die();
} else {
	include(_LD_BACKEND_PATH.'/config.php');
}

//include some useful files
include(_LD_BACKEND_PATH.'/admin.links.php');
include(_LD_BACKEND_PATH.'/admin.categories.php');
include(_LD_BACKEND_PATH.'/admin.tools.php');
include(_LD_BACKEND_PATH.'/admin.config.php');
include(_LD_BACKEND_PATH.'/admin.css.php');
include(_LD_BACKEND_PATH.'/admin.comments.php');
include(_LD_BACKEND_PATH.'/admin.cpanel.php');
include(_LD_BACKEND_PATH.'/admin.importexport.php');
include(_LD_BACKEND_PATH.'/admin.groups.php');
include(_LD_BACKEND_PATH.'/linkdirectory.linkthumbnail.php');



//get some variables
$cid = mosGetParam( $_POST, 'cid', array(0));
$id  = intval( mosGetParam( $_REQUEST, 'id', 0 ) );
$error = mosGetParam( $_REQUEST, 'error', '' );

//Cache activation
$cache =& mosCache::getCache( 'com_linkdirectory' );

//let's go :)
switch ($task) {
	#Category functions
	case 'new':
		mosCache::cleanCache( 'com_linkdirectory' );
		$cache->call('editCategory', 0 );
		break;

	case 'edit':
		mosCache::cleanCache( 'com_linkdirectory' );
		$cache->call('editCategory', intval( $cid[0] ) );
		break;

	case 'editA':
		mosCache::cleanCache( 'com_linkdirectory' );
		$cache->call('editCategory', intval( $id ) );
		break;

	case 'save':
	case 'apply':
		mosCache::cleanCache( 'com_linkdirectory' );
		$cache->call('saveCategory', $task );
		break;

	case 'remove':
		$cache->call('removeCategories', $cid );
		break;

	case 'publish':
		mosCache::cleanCache( 'com_linkdirectory' );
		$cache->call('publishCategories', $id, $cid, 1 );
		break;

	case 'unpublish':
		mosCache::cleanCache( 'com_linkdirectory' );
		$cache->call('publishCategories', $id, $cid, 0 );
		break;

	case 'cancel':
		global $database;
		$row = new snrCats( $database );
		$row->bind( $_POST );
		$row->checkin();
		mosRedirect('index2.php?option=com_linkdirectory&task=categories');
		break;

	case 'orderup':
		mosCache::cleanCache( 'com_linkdirectory' );
		$cache->call('orderCategory', intval( $cid[0] ), -1 );
		break;

	case 'orderdown':
		mosCache::cleanCache( 'com_linkdirectory' );
		$cache->call('orderCategory', intval( $cid[0] ), 1 );
		break;

	case 'accesspublic':
		$cache->call('accessMenu', intval( $cid[0] ), 0 );
		break;

	case 'accessregistered':
		$cache->call('accessMenu', intval( $cid[0] ), 1 );
		break;

	case 'accessspecial':
		$cache->call('accessMenu', intval( $cid[0] ), 2);
		break;

	case 'saveorder':
		mosCache::cleanCache( 'com_linkdirectory' );
		$cache->call('saveOrder', $cid );
		break;

	case 'categories':
		$cache->call('showCategories', $option );
		break;

		#Weblinks functions
	case 'newlink':
		mosCache::cleanCache( 'com_linkdirectory' );
		$cache->call('editWeblink', $option, 0 );
		break;

	case 'editlink':
		$cache->call('editWeblink', $option, $cid[0] );
		break;

	case 'editlinkA':
		mosCache::cleanCache( 'com_linkdirectory' );
		$cache->call('editWeblink', $option, $id );
		break;

	case 'savelink':
		$cache->call('saveWeblink', $option, $id );
		break;

	case 'removelink':
		$cache->call('removeWeblinks', $cid, $option );
		break;

	case 'publishlink':
		$cache->call('publishWeblinks', $cid, 1, $option );
		break;

	case 'unpublishlink':
		$cache->call('publishWeblinks', $cid, 0, $option );
		break;

	case 'cancellink':
		global $database;
		$row = new snrLinks( $database );
		$row->bind( $_POST );
		$row->checkin();
		mosRedirect('index2.php?option=com_linkdirectory&task=weblinks');
		break;

	case 'weblinks':
		$cache->call('showWeblinks', $option );
		break;

		#Configuration functions
	case 'config':
		$cache->call('Config');
		break;

	case 'saveconfig':
		$cache->call('SaveConfig');
		break;

	case 'cancelconfig':
		mosRedirect('index2.php?option=com_linkdirectory');
		break;

		#Export/Import functions
	case 'export':
		addCssForIcon('icon-32-export','export_f2.png');
		$cache->call('ExportLinks');
		break;

	case 'export2':
		$cache->call('exportLink', $option);
		break;

	case 'import':
		addCssForIcon('icon-32-import','import_f2.png');
		$cache->call('ImportLinks');
		break;

	case 'import2':
		$cache->call('ImportLink', $option, $parent_id, $access);
		break;

		#Comments functions
	case 'newcomment':
		if ($ld->commentlink > 0 ) {
			$cache->call('editComment', $option, 0 );
		} else {
			mosRedirect('index2.php?option=com_linkdirectory','Comment System is Disabled!');
		}
		break;

	case 'editcomment':
		if ($ld->commentlink > 0 ) {
			$cache->call('editComment', $option, $cid[0] );
		} else {
			mosRedirect('index2.php?option=com_linkdirectory','Comment System is Disabled!');
		}
		break;

	case 'editcommentA':
		if ($ld->commentlink > 0 ) {
			$cache->call('editComment', $option, $id );
		} else {
			mosRedirect('index2.php?option=com_linkdirectory','Comment System is Disabled!');
		}
		break;

	case 'savecomment':
		if ($ld->commentlink > 0 ) {
			$cache->call('saveComment', $option );
		} else {
			mosRedirect('index2.php?option=com_linkdirectory','Comment System is Disabled!');
		}
		break;

	case 'removecomment':
		if ($ld->commentlink > 0 ) {
			$cache->call('removeComments', $cid, $option );
		} else {
			mosRedirect('index2.php?option=com_linkdirectory','Comment System is Disabled!');
		}
		break;

	case 'publishcomment':
		if ($ld->commentlink > 0 ) {
			$cache->call('publishComments', $cid, 1, $option );
		} else {
			mosRedirect('index2.php?option=com_linkdirectory','Comment System is Disabled!');
		}
		break;

	case 'unpublishcomment':
		if ($ld->commentlink > 0 ) {
			$cache->call('publishComments', $cid, 0, $option );
		} else {
			mosRedirect('index2.php?option=com_linkdirectory','Comment System is Disabled!');
		}
		break;

	case 'cancelcomment':
		if ($ld->commentlink > 0 ) {
			global $database;
			$row = new snrComments( $database );
			$row->bind( $_POST );
			$row->checkin();
			mosRedirect('index2.php?option=com_linkdirectory&task=comments');
		} else {
			mosRedirect('index2.php?option=com_linkdirectory','Comment System is Disabled!');
		}
		break;

	case 'comments':
		if ($ld->commentlink > 0 ) {
			$cache->call('showComments', $option );
		} else {
			mosRedirect('index2.php?option=com_linkdirectory','Comment System is Disabled!');
		}
		break;

		#Some functions
	case 'about':
		About();
		break;

	default:
		$cache->call('CPanel');
		break;

	case 'editcss':
		$cache->call('editCSS', $ld->template);
		break;

	case 'savecss':
		$cache->call('saveCSS', $option);
		break;

	case 'cssreport':
		$cache->call('Report', $error);
		break;

		#Group settings - New Added but not work now...
	case 'setgroup':
		$cache->call('Groups', $option);
		break;

	case 'newgroup':
		$cache->call('EditGroup', 0, $option);
		break;

	case 'editgroup':
		$cache->call('EditGroup', $cid[0], $option);
		break;

	case 'editgroupA':
		$cache->call('EditGroup', $id, $option);
		break;

	case 'delgroup':
		$cache->call('DelGroup', $cid, $option);
		break;

	case 'savegroup':
		$cache->call('SaveGroup', $option);
		break;

	case 'cancelgroup':
		$row = new snrGroups( $database );
		$row->bind( $_POST );
		$row->checkin();
		mosRedirect('index2.php?option=com_linkdirectory&task=setgroup');
		break;
}
?>