<?php defined( '_VALID_MOS' ) or die( 'Restricted access' );
/**
 * @ H2N Link Directory 1.0.0 install.linkdirectory.php
 * @ Copyright (C) 2008 Harry Klein - www.joomla-hklein.de
 * @
 * @ Link Directory 1.1 install.linkdirectory.php
 * @ Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 * @
 * @ $Id: install.linkdirectory.php,v 1.15 2009/08/14 22:51:08 harry Exp $
 * @
 **/


function com_install(){
	$errorMsg='';
	$errorMsg.=copyAdminMenuToolbarIcons();
	updateAdministrationMenuIcons();
	$errorMsg.=updateDbSchema();
	installJoomlaFishFile();
	installJoomla15fixes();
	echo $errorMsg;
}

/**
 * Copy new admin menu toolbar images.
 */
function copyAdminMenuToolbarIcons(){
	global $mosConfig_absolute_path;
	$errorMsg='';
	$files = array ('import_f2.png','export_f2.png');
	foreach ($files as $file){
		$dest=$mosConfig_absolute_path.'/administrator/images/'.$file;
		$src=$mosConfig_absolute_path .'/administrator/components/com_linkdirectory/images/'.$file;
		if (! file_exists($dest)){
			$succeess=@copy($src, $dest);
			if (!$succeess) {
				$errorMsg.="<span class=\"error\">Warning: </span>Can't copy file $src to $dest<br />";
			}
		}
	}
	return $errorMsg;
}

/**
 *
 */
function updateAdministrationMenuIcons(){
	global $database;
	
	$database->setQuery( "SELECT id FROM #__components WHERE name= 'Link Directory'" );
	$id = $database->loadResult();
	
	if( defined('_JEXEC') ) {
		$ln_home='component.png';
	} else {
		$ln_home='home.png';
	}

	//main link
	$database->setQuery( "UPDATE #__components SET admin_menu_img = '../includes/js/ThemeOffice/$ln_home' WHERE id='$id'");
	$database->query();

	//control panel
	$database->setQuery( "UPDATE #__components SET admin_menu_img = '../includes/js/ThemeOffice/controlpanel.png' WHERE parent='$id' AND name = 'Control Panel'");
	$database->query();

	//category manager
	$database->setQuery( "UPDATE #__components SET admin_menu_img = '../includes/js/ThemeOffice/categories.png' WHERE parent='$id' AND name = 'Category Manager'");
	$database->query();

	//weblink manager
	$database->setQuery( "UPDATE #__components SET admin_menu_img = '../includes/js/ThemeOffice/globe4.png' WHERE parent='$id' AND name = 'Web Link Manager'");
	$database->query();

	//comment manager
	$database->setQuery( "UPDATE #__components SET admin_menu_img = '../includes/js/ThemeOffice/content.png' WHERE parent='$id' AND name = 'Comment Manager'");
	$database->query();

	//configuration
	$database->setQuery( "UPDATE #__components SET admin_menu_img = '../includes/js/ThemeOffice/config.png', admin_menu_link = 'option=com_linkdirectory&task=config&hidemainmenu=1' WHERE parent='$id' AND name = 'Configuration'");
	$database->query();

	//about me
	$database->setQuery( "UPDATE #__components SET admin_menu_img = '../includes/js/ThemeOffice/credits.png' WHERE parent='$id' AND name = 'About Me'");
	$database->query();

	//import
	$database->setQuery( "UPDATE #__components SET admin_menu_img = '../includes/js/ThemeOffice/backup.png' WHERE parent='$id' AND name = 'Import Web Links'");
	$database->query();

	//export
	$database->setQuery( "UPDATE #__components SET admin_menu_img = '../includes/js/ThemeOffice/restore.png' WHERE parent='$id' AND name = 'Export Web Links'");
	$database->query();
}

/**
 * 	Fixes for Jommla 1.5.x
 */
function installJoomla15fixes(){
	global $mosConfig_absolute_path;
	if( defined('_JEXEC') ){
		@copy($mosConfig_absolute_path .'/administrator/components/com_linkdirectory/language/english.php', $mosConfig_absolute_path.'/administrator/components/com_linkdirectory/language/en-GB.php');
		@copy($mosConfig_absolute_path .'/administrator/components/com_linkdirectory/language/german.php', $mosConfig_absolute_path.'/administrator/components/com_linkdirectory/language/de-DE.php');
	}
}

/**
 * 	Aadd joomfish support files if joomfish was installed.
 */
function installJoomlaFishFile(){
	global $mosConfig_absolute_path;
	if (file_exists($mosConfig_absolute_path."/administrator/components/com_joomfish/contentelements/content.xml")){
		@copy($mosConfig_absolute_path .'/administrator/components/com_linkdirectory/joomfish/linkdirectory_cats.xml', $mosConfig_absolute_path.'/administrator/components/com_joomfish/contentelements/linkdirectory_cats.xml');
		@copy($mosConfig_absolute_path .'/administrator/components/com_linkdirectory/joomfish/linkdirectory_links.xml', $mosConfig_absolute_path.'/administrator/components/com_joomfish/contentelements/linkdirectory_links.xml');
	}
}

/**
  *
 * @return ggf. eine Fehlermeldung
 */
function updateDbSchema(){
	global $database;
	$errorMsg='';
	
	$prefix = $database->_table_prefix;
	$tn = $prefix.'ldcomment';
	$fields = $database->getTableFields(array($tn));
	$foundPublished = false;
	$foundChecked_out  = false;
	$foundChecked_out_time = false;
	$foundPublished = isset( $fields[$tn]['published'] );
	$foundChecked_out = isset( $fields[$tn]['checked_out'] );
	$foundChecked_out_time = isset( $fields[$tn]['checked_out_time'] );
	$foundType = isset( $fields[$tn]['type'] );

	if ( !($foundPublished && $foundChecked_out && $foundChecked_out_time)) {
		$database->setQuery( "ALTER TABLE #__ldcomment ADD `published` TINYINT( 1 ) NOT NULL , ADD `checked_out` INT( 11 ) NOT NULL , ADD `checked_out_time` DATETIME NOT NULL");
		$database->query();
		$databaseErrorNum = $database->getErrorNum();
		if ( ($databaseErrorNum != 0) && ( $databaseErrorNum != 1060) ) {
			$errorMsg.="<span class=\"error\">Warning: </span>Can't updating database: " . htmlspecialchars($database->getErrorMsg(),ENT_QUOTES) .'<br />';
		}
	}
	
	if ( !($foundType)) {
		$database->setQuery( "ALTER TABLE #__ldcomment ADD `type` tinyint(4) NOT NULL default '0' AFTER `user_id`");
		$database->query();
		$databaseErrorNum = $database->getErrorNum();
		if ( ($databaseErrorNum != 0) && ( $databaseErrorNum != 1060) ) {
			$errorMsg.="<span class=\"error\">Warning: </span>Can't updating database: " . htmlspecialchars($database->getErrorMsg(),ENT_QUOTES) .'<br />';
		}
	}
	

	$tn = $prefix.'ldlinks';
	$fields = $database->getTableFields(array($tn));
	$foundDescription_long = false;
	$foundDescription_long	= isset( $fields[$tn]['description_long'] );
	
	$foundThumbUrl = false;
	$foundThumbUrl	= isset( $fields[$tn]['thumburl'] );
	
	$foundImage = false;
	$foundImage	= isset( $fields[$tn]['image'] );
	
	
	
	// fix rating type int(11) ->float 
	if (isset($fields[$tn]['rating']) && ($fields[$tn]['rating'] != 'float')) {
		$database->setQuery( "ALTER TABLE #__ldlinks CHANGE `rating` `rating` FLOAT NOT NULL DEFAULT '0'");
		$database->query();
		$databaseErrorNum = $database->getErrorNum();
		if ( ($databaseErrorNum != 0) && ( $databaseErrorNum != 1060) ) {
			$errorMsg.="<span class=\"error\">Warning: </span>Can't updating database: " . htmlspecialchars($database->getErrorMsg(),ENT_QUOTES) .'<br />';
		}
	}

	if (!$foundDescription_long) {
		$database->setQuery( "ALTER TABLE #__ldlinks ADD `description_long` TEXT NOT NULL AFTER `description`");
		$database->query();
		$databaseErrorNum = $database->getErrorNum();
		if ( ($databaseErrorNum != 0) && ( $databaseErrorNum != 1060) ) {
			$errorMsg.="<span class=\"error\">Warning: </span>Can't updating database: " . htmlspecialchars($database->getErrorMsg(),ENT_QUOTES) .'<br />';
		}
	}
	
	if (!$foundThumbUrl) {
		$database->setQuery( "ALTER TABLE #__ldlinks ADD `thumburl` varchar(250) NOT NULL AFTER `url`");
		$database->query();
		$databaseErrorNum = $database->getErrorNum();
		if ( ($databaseErrorNum != 0) && ( $databaseErrorNum != 1060) ) {
			$errorMsg.="<span class=\"error\">Warning: </span>Can't updating database: " . htmlspecialchars($database->getErrorMsg(),ENT_QUOTES) .'<br />';
		}
	}
	
	if (!$foundImage) {
		$database->setQuery( "ALTER TABLE #__ldlinks ADD `image` varchar(255) NOT NULL AFTER `thumburl`");
		$database->query();
		$databaseErrorNum = $database->getErrorNum();
		if ( ($databaseErrorNum != 0) && ( $databaseErrorNum != 1060) ) {
			$errorMsg.="<span class=\"error\">Warning: </span>Can't updating database: " . htmlspecialchars($database->getErrorMsg(),ENT_QUOTES) .'<br />';
		}
	}
	
	
	
	return $errorMsg;
}

?>
