<?php defined( '_VALID_MOS' ) or die( 'Restricted access' );
/**
 * @ H2N Link Directory 1.0.0 admin.css.php
 * @ Copyright (C) 2008 Harry Klein - www.joomla-hklein.de
 * @
 * @ Link Directory 1.1 admin.css.php
 * @ Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 *
 * @ $Id: admin.css.php,v 1.8 2009/08/14 22:45:03 harry Exp $
 *
 **/


function editCSS($template) {
	$tempname = $template;
	$template = _LD_FRONTEND_PATH .'/templates/'.$tempname.'/css/linkdirectory.css';

	if ($fp = fopen( $template, 'r' )) {
		$content = fread( $fp, filesize( $template ) );
		$content = htmlspecialchars( $content );
		$option = '';
		editCSSSource( $template, $content, $option , $tempname );
	} else {
		$error = _LD_CAN_NOT_OPEN_TEMPLATE;
		mosRedirect('index3.php?option=com_linkdirectory&task=cssreport&error='.$error);
	}
}

function editCSSSource( $template, &$content, $option, $tempname ) {
	?>
<form action="index2.php" method="post" name="adminForm">
<table cellpadding="1" cellspacing="1" border="0" width="100%">
	<tr>
		<td width="280">
		<table class="adminheading">
			<tr>
				<th class="templates">CSS Editor</th>
			</tr>
		</table>
		</td>
		<td width="260"><span class="componentheading"><?php echo _LD_CSSFILEIS;?>
		<small>(<?php echo $tempname;?>)</small> : <b><?php echo is_writable($template) ? '<font color="green"> '._LD_WRITEABLE.'</font>' : '<font color="red"> '._LD_UNWRITEABLE.'</font>' ?></b>
		</span></td>
	</tr>
</table>

<table class="adminform">
	<tr>
		<th><?php echo $tempname; ?></th>
	</tr>
	<tr>
		<td><textarea style="width: 100%; height: 300px" cols="110" rows="25"
			name="filecontent" class="inputbox"><?php echo $content; ?></textarea></td>
	</tr>
</table>

<input type="hidden" name="template" value="<?php echo $template; ?>" />
<input type="hidden" name="option" value="com_linkdirectory" /> 
<input type="hidden" name="task" value="savecss" /> <br />
<center><input type="submit" name="submit"
	value="<?php echo _LD_SAVE_CSS;?>" class="button" /> <br />
<br />
<a href="javascript:close();"><?php echo _LD_CLOSE;?></a></center>
</form>
	<?php
}

function saveCSS( $option ) {
	$template = mosGetParam( $_POST, 'template', '' );
	$filecontent = mosGetParam( $_POST, 'filecontent', '', _MOS_ALLOWHTML );

	if ( !$filecontent ) {
		$error = _LD_CSS_IS_EMPTY;
		mosRedirect('index3.php?option=com_linkdirectory&task=cssreport&error='.$error);
	}

	clearstatcache();
	if ( is_writable( $template ) == false ) {
		$error = _LD_CAN_NOT_WRITE_TEMPLATE;
		echo $template;
		return;
		mosRedirect('index3.php?option=com_linkdirectory&task=cssreport&error='.$error);
	}

	if ($fp = fopen ($template, 'w')) {
		fputs( $fp, stripslashes( $filecontent ) );
		fclose( $fp );
		$error = _LD_CSS_SAVED;
		mosRedirect('index3.php?option=com_linkdirectory&task=cssreport&error='.$error);
	} else {
		$error = _LD_CAN_NOT_WRITE_TEMPLATE;
		mosRedirect('index3.php?option=com_linkdirectory&task=cssreport&error='.$error);
	}
}


function Report($error) {
	global $mosConfig_live_site;
	?>
<table width="100%">
	<tr>
		<td align="center"><img
			src="<?php echo $mosConfig_live_site;?>/administrator/components/com_linkdirectory/images/ldh2nlogo.png"
			alt="LD Logo" /></td>
	</tr>
	<tr>
		<td height="150" align="center">
		<h3><?php echo $error;?></h3>
		</td>
	</tr>
	<tr>
		<td height="150" align="center"><?php if (! $error) { ?><a href="javascript:history.go(-1);"><?php echo _LD_CONTINUE;?></a>
		<br />
		<br />
		<?php } ?>
		<a href="javascript:close();"><?php echo _LD_CLOSE;?></a></td>
	</tr>
</table>
	<?php
}

?>