<?php defined( '_VALID_MOS' ) or die( 'Restricted access' );
/**
 * @ H2N Link Directory 1.0.0 admin.groups.php
 * @ Copyright (C) 2008 Harry Klein - www.joomla-hklein.de
 * @
 * @ Link Directory 1.1 admin.groups.php
 * @ Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 **/


function Groups($option) {
	global $database;

	$search = trim(strtolower(mosGetParam($_POST, 'search', '')));
	$limit = intval(mosGetParam($_POST, 'limit', 10));
	$limitstart = intval(mosGetParam($_POST, 'limitstart', 0));
	$where = array();
	if ($search) {
		$where[] = "LOWER(groups_name) LIKE '%$search%'";
	}
	// get the total number of records
	$database->setQuery("SELECT count(*) FROM #__ldgroups"
	. (count($where) ? "\nWHERE " . implode(' AND ', $where) : "")
	);

	$total = $database->loadResult();

	echo $database->getErrorMsg();

	if ($limit > $total) {
		$limitstart = 0;
	}
	$database->setQuery("SELECT *"
	. "\nFROM #__ldgroups"
	. (count($where) ? "\nWHERE " . implode(' AND ', $where) : "")
	. "\nORDER BY groups_name"
	. "\nLIMIT $limitstart,$limit"
	);

	$rows = $database->loadObjectList();

	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	require_once($GLOBALS['mosConfig_absolute_path'] . '/administrator/includes/pageNavigation.php');
	$pageNav = new mosPageNav($total, $limitstart, $limit);

	Groups_HTML::showGroups($option, $rows, $search, $pageNav);
}


function EditGroup($group_id, $option) {
	global $database;

	$row = new snrGroups( $database );
	// load the row from the db table
	$row->load( $group_id );

	$musers = array();
	$toAddUsers = array();
	// get selected members
	if ($row->groups_members) {
		$database->setQuery("SELECT id,name,username "
		. "\n FROM #__users "
		. "\nWHERE id IN (" . $row->groups_members . ")"
		. "\nORDER BY name ASC"
		);
		$usersInGroup = $database->loadObjectList();

		if (!$database->getErrorNum()) {
			foreach($usersInGroup as $user) {
				$musers[] = mosHTML::makeOption($user->id, $user->id . "-" . $user->name . "(" . $user->username . ")");
			}
		}
	}
	// get non selected members
	$query = "SELECT id,name,username FROM #__users ";
	if ($row->groups_members) {
		$query .= "\nWHERE id NOT IN (" . $row->groups_members . ")" ;
	}
	$query .= "\nORDER BY name ASC";
	$database->setQuery($query);
	$usersToAdd = $database->loadObjectList();
	foreach($usersToAdd as $user) {
		$toAddUsers[] = mosHTML::makeOption($user->id, $user->id . "-" . $user->name . "(" . $user->username . ")");
	}

	$usersList = mosHTML::selectList($musers, 'users_selected[]',
        'class="inputbox" size="15" onDblClick="moveOptions(document.adminForm[\'users_selected[]\'], document.adminForm.users_not_selected)" multiple="multiple"', 'value', 'text', null);
	$toAddUsersList = mosHTML::selectList($toAddUsers,
        'users_not_selected', 'class="inputbox" size="15" onDblClick="moveOptions(document.adminForm.users_not_selected, document.adminForm[\'users_selected[]\'])" multiple="multiple"',
        'value', 'text', null);

	Groups_HTML::editGroups($option, $row, $usersList, $toAddUsersList);
}


function DelGroup($cid, $option) {
	global $database;
	if (!is_array($cid) || count($cid) < 1) {
		echo "<script> alert('" . _DML_SELECT_ITEM_DEL . "'); window.history.go(-1);</script>\n";
		exit;
	}
	if (count($cid)) {
		$cids = implode(',', $cid);
			
		$database->setQuery("DELETE FROM #__ldgroups WHERE groups_id IN ($cids)");
		if (!$database->query()) {
			echo "<script> alert('" . $database->getErrorMsg() . "'); window.history.go(-1); </script>\n";
		}
	}
	mosRedirect("index2.php?option=com_linkdirectory&task=setgroup");
}


function SaveGroup($option) {
	global $database;
	$row = new snrGroups($database);
	$isNew = ($row->id == 0);
	if (!$row->bind($_POST)) {
		echo "<script> alert('" . $row->getError() . "'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script> alert('" . $row->getError() . "'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script> alert('" . $row->getError() . "'); window.history.go(-1); </script>\n";
		exit();
	}
	$row->checkin();
	$members = mosGetParam($_POST, 'users_selected', array());
	$members_imploded = implode(',', $members);

	$database->setQuery("UPDATE #__ldgroups SET groups_members='" . $members_imploded . "' WHERE groups_id=$row->groups_id");
	$database->query();

	mosRedirect("index2.php?option=com_linkdirectory&task=setgroup");
}
?>